
#include "stdio.h"
#include "conio.h"
#include "string.h"

// funzione che trova la lunghezza di una stringa
// passata come parametro in input
int lungh_str(char v[])
{
    asm  {
        MOV EBX,v     // EBX punta all' inizio del vettore acquisendo il contenuto di v
        MOV ESI,0     // ESI punta all'elemento zero (e successivamente agli altri)
        Ciclo:
        CMP Byte Ptr[EBX + ESI],0   // controlla se l'elemento puntato e' terminale ('\0')
        JE  Fine                  // se lo e' salta alla fine del progr.
        INC ESI             // altrimenti... incrementa ESI di uno
        JMP Ciclo           // ripete il ciclo di scansione col nuovo valore di ESI
        Fine:
    }

    return(_ESI);        // ritorna ESI, che corrisponde poi al n di caratteri letti
}

// copia una stringa in un altra, passate entrambe come parametri
void str_copia(char s1[], char s2[])
{
    asm  {
        MOV EBX,s1          // EBX punta alla prima stringa (destinazione della copia)
        MOV EDX,s2          // EDX punta alla seconda stringa (sorgente della copia)
        MOV ESI,0        // ESI serve per puntare al primo elemento di entrambe le stringhe
        Ciclo_Copia:
        MOV AL, Byte Ptr[EDX + ESI]   // passa il carattere puntato da ESI nella str. sorgente
        MOV Byte Ptr[EBX + ESI],AL   // copia sempre in posizione ESI il carattere nella str. destinaz.
        INC ESI                    // muove ESI in avanti di 1
        CMP Byte Ptr[EDX + ESI],0     //  controlla quando nella stringa si e' raggiunto l'ultimo carattere
        JNE Ciclo_Copia           // se non e' stato raggiunto...
        MOV Byte Ptr[EBX + ESI],0     // altrimenti pone '\0' anche nella stringa copia e termina
    }
}

// nella stessa stringa converte tutti i caratteri a-z
// da minuscoli a maiuscoli
void maiuscolo_semplice(char s[])
{
   asm  {
        MOV EBX,s         // EBX punta alla stringa s
        MOV ESI,0         // ESI punta al primo elemento di s
        Ciclo:
        MOV AL, Byte Ptr[EBX + ESI]      // carica in AL il carattere corrente
        CMP AL,'a'                 // confronta il carattere letto con a minuscolo
        JB Non_Cambia      // se e' inferiore ad 'a', allora non converte in maiuscole
        CMP AL,'z'                // confronta il carattere letto con z minuscolo
        JA  Non_Cambia     // se e' inferiore a 'z', allora non converte in maiuscole
        SUB AL,32                 // tramite un shift del codice di 32 (dec.) converte in maiuscolo
        MOV Byte Ptr[EBX + ESI],AL   // ri-memorizza AL nella posizione ESI
        Non_Cambia:
        INC ESI                  // passa al carattere successivo
        CMP Byte Ptr[EBX + ESI],0    // controlla se il carattere  '\0' ed eventualmente termina
        JNE Ciclo
    }
}

//  riceve come parametro una stringa il cui contenuto viene
// convertito in maiuscolo (caratteri minuscoli a-z)
char* maiuscolo(char s[])
{
    static char s2[30];    // alloca s2 in modo statico (la variabile sopravvive alla funzione)
    char* ps;         // puntatore a carattere (o seq. di caratteri = stringa)

    ps = s2;          // copia s2 in ps e quindi ps  un puntatore alla stringa s2

    asm  {
        MOV EBX,ps      // fa' puntare EBX all'inizio della stringa s2
        MOV EDX,s       // fa' puntare EDX all'inizio della stringa s
        MOV ESI,0           // pone il puntatore di scansione ESI a 0
        Ciclo:
        MOV AL, Byte Ptr[EDX + ESI]    // carica in AL il primo carattere di della stringa s
        CMP AL,'a'
        JB Non_Cambia               // controlla se  inferiore ad 'a'
        CMP AL,'z'
        JA  Non_Cambia             // controlla se  superiore a 'z'
        // se entrambe le condizioni precedenti non sono verificate
        // ossia il carattere  tra a e z...        
        SUB AL,32        // effettua uno shift di 32 che porta da lettere minuscole a maiuscole
        Non_Cambia:
        MOV Byte Ptr[EBX + ESI],AL       // sposta AL nella posizione ESI di s2
        INC ESI                      // incrementa ESI
        CMP Byte Ptr[EDX + ESI],0        // controlla se su s la scansione ha raggiunto un '\0'
        JNE Ciclo
        MOV Byte Ptr[EBX + ESI],0   // allora esce e pone un '\0' (0 dec) (terminatore) anche se s2
    }

    return(s2);   // rende un puntatore ad s2
}

// programma main per il test delle funzioni
void main()
{
   char st[30], st2[30];

   printf("Test della funzione assembly di calcolo della lunghezza di una stringa:\n");
   printf("Fornisci la stringa:  ");
   gets(st);
   printf("\n\nLa lunghezza della stringa %s e': %i", st, lungh_str(st));

   str_copia(st2,st);
   printf("\n\nLa copia della stringa %s e' %s.\n", st, st2);

   printf("La stringa %s in maiuscolo risulta: %s", st, maiuscolo(st));
   maiuscolo_semplice(st);
   printf("\n\nLa stringa in maiuscolo risulta: %s (funzione semplificata)", st);   

   getch();
}
